(*
Copyright  2007 Logan Rockmore

This script gets the names of all of the mailboxes in Mail.app

*)

set mailboxesWithUnreadMessages to {}

set MailboxKillList to {} as list

tell application "System Events" to if (application processes whose name is "Mail") is {} then return {-1}

tell application "Mail"
	
	set everyAccount to every account
	repeat with currentAccount in everyAccount
		set everyMailbox to every mailbox of currentAccount
		if (count of everyMailbox) is greater than 0 then
			
			repeat with currentMailbox in everyMailbox
				
				set mailboxName to name of currentMailbox
				try
					if (MailboxKillList does not contain mailboxName) then
						
						set unreadCount to unread count of currentMailbox
						
							-- fix all capitals Inbox for the display
							if mailboxName = "INBOX" then
								set mailboxName to "Inbox"
							end if
							
							set mailboxesWithUnreadMessages to mailboxesWithUnreadMessages & mailboxName
						
						set totalUnreadMessages to totalUnreadMessages + unreadCount
					end if
				end try
				
			end repeat
		end if
	end repeat
	
	-- count unread messages in the local mailboxes
	set localMailboxes to every mailbox
	if ((count of localMailboxes) is greater than 0) then
		repeat with currentMailbox in localMailboxes
			set mailboxName to (name of currentMailbox) as string
			if (MailboxKillList does not contain mailboxName) then
				
				set mailboxesWithUnreadMessages to mailboxesWithUnreadMessages & mailboxName
				
			end if
		end repeat
	end if
end tell

return mailboxesWithUnreadMessages