(*
Copyright © 2006 Logan Rockmore

This script gets the count of unread messages from Mail.app

*)

delay 0.5 -- delay so that when quitting Mail.app, we don't see it as open

set totalUnreadMessages to 0
set mailboxesWithUnreadMessages to {}

set MailboxKillList to {} as list

if isMailAppRunning() = false then return {-1}

tell application "Mail"
	
	-- count unread messages in the account mailboxes
	set everyAccount to every account
	repeat with currentAccount in everyAccount
		set everyMailbox to every mailbox of currentAccount
		if (count of everyMailbox) is greater than 0 then
			
			repeat with currentMailbox in everyMailbox
				
				set mailboxName to name of currentMailbox
				try
					if (MailboxKillList does not contain mailboxName) then
						
						set unreadCount to unread count of currentMailbox
						
						if (unreadCount > 0) then
							
							-- fix all capitals Inbox for the display
							if mailboxName = "INBOX" then
								set mailboxName to "Inbox"
							end if
							
							set mailboxesWithUnreadMessages to mailboxesWithUnreadMessages & mailboxName & unreadCount
						end if
						
						set totalUnreadMessages to totalUnreadMessages + unreadCount
					end if
				end try
				
			end repeat
		end if
	end repeat
	
	-- count unread messages in the local mailboxes
	set localMailboxes to every mailbox
	if ((count of localMailboxes) is greater than 0) then
		repeat with currentMailbox in localMailboxes
			set mailboxName to (name of currentMailbox) as string
			if (MailboxKillList does not contain mailboxName) then
				
				set unreadCount to unread count of currentMailbox
				
				if (unreadCount > 0) then
					set mailboxesWithUnreadMessages to mailboxesWithUnreadMessages & mailboxName & unreadCount
				end if
				
				set totalUnreadMessages to totalUnreadMessages + unreadCount
				
			end if
		end repeat
	end if
end tell

return mailboxesWithUnreadMessages



on isMailAppRunning()
	
	tell application "Finder"
		set ProcessList to name of processes
	end tell
	
	set x2 to (length of ProcessList)
	
	repeat with x1 from 1 to x2
		if (item (x1) of ProcessList as string) = "Mail" then
			return true
		end if
	end repeat
	
	return false
	
end isMailAppRunning