var currentVersion = 1.51;
var newVersion;
var newVersionLink = "http://www.apple.com/downloads/dashboard/email_messaging/mailwidget.html";

/*stored preferences*/
var widgetID;
var acntSav;
var passSav;
var periodSav;
var announceSav;
var updateSav;

var backSide = false;
var isHidden = false;

/*SSL and stuff*/
var lookUpTable = new Array();
var activeType;
var activeHost;
var activePort;
var activeSSL;
var activeUser;

var failCounter = 0;

function debug( string ) {
	//alert(string);
}

function loaded() {
	debug("loaded()");

	/*generate back buttons*/
	var verifyButton = document.getElementById( "verifyButton" );
	var doneButton = document.getElementById( "doneButton" );
	createGenericButton( verifyButton, getLocalizedString( 'verifyButton' ), verifyMail );
	createGenericButton( doneButton, getLocalizedString( 'doneButton' ), hideBack );

	/*initialize functionality*/
	assignElements();
	loadLanguagePack()
	loadPreferences();
	loadFromMail();
	checkForUpdate();
	checkMail();
}

function assignElements() {
	debug("assignElements()");

	/*front elements*/
	front = document.getElementById( "front" );
	mailCounter = document.getElementById( "mailCount" );
	activityIndicator = document.getElementById( "activityIndicator" );
	frontID = document.getElementById( "activeMail" );
	updateIndicator = document.getElementById( "updateIndicator" );

	/*back elements*/
	back = document.getElementById( "back" );
	acntIn = document.getElementById( "accountPopUp" );
	passIn = document.getElementById( "passwordString" );
	periodIn = document.getElementById( "periodicBox" );
	announceIn = document.getElementById( "announceBox" );
	updateIn = document.getElementById( "updateBox" );
	statusLED = document.getElementById( "statusLED" );
}

function loadPreferences() {
	debug("loadPreferences()");

	if ( window.widget ) {
		widgetID = widget.identifier;
		acntSav = widget.preferenceForKey( widgetID + "Account" );
		passSav = widget.preferenceForKey( widgetID + "Password" );
		periodSav = widget.preferenceForKey( widgetID + "Periodic" );
		announceSav = widget.preferenceForKey( widgetID + "Announce" );
		updateSav = widget.preferenceForKey( widgetID + "Update" );
	}

	if ( !acntSav ) {
		acntSav = null;
		setTimeout( 'showBack();', 2000 );
	}

	if ( !passSav ) {
		passSav = null;
	}

	//security violation
	if ( passSav ) {
		passIn.value = decode( passSav );
	}

	/* setting the flags */
	if ( periodSav == undefined ) {
		periodSav = false;
	}

	if ( periodSav ) {
		periodIn.checked = true;
	} else {
		periodIn.checked = false;
	}

	if ( announceSav == undefined ) {
		announceSav = true;
	}

	if ( announceSav ) {
		announceIn.checked = true;
	} else {
		announceIn.checked = false;
	}

	if ( updateSav == undefined ) {
		updateSav = true;
	}

	if ( updateSav ) {
		updateIn.checked = true;
	} else {
		updateIn.checked = false;
	}
}

function loadFromMail() {
	debug("loadFromMail()");

	if ( window.widget ) {
		debug(" : 1");
		var getAccount = widget.system( "/usr/bin/osascript MailWidget.scpt getAccounts", null ).outputString;
		debug("2 : " + getAccount);		
		var temp = getAccount.split( ";" );
		debug("3 : " + temp);
		
		for ( i = 0; i < (temp.length - 1); i += 7 ) {
			debug(" : 3");
			if ( temp[i + 1] == acntSav ) {
				debug(" : 4");
				var newEntry = new Option( temp[i], temp[i + 1], false, true );
				activeType = temp[i + 2];
				activeHost = temp[i + 3];
				activePort = temp[i + 4];
				activeSSL = temp[i + 5];
				activeUser = temp[i + 6];
			} else {
				debug(" : 5");
				var newEntry = new Option( temp[i], temp[i + 1], false, false );
			}

			var tempArray = [ temp[i], temp[i+1], temp[i+2], temp[i+3], temp[i+4], temp[i+5], temp[i+6] ];
			lookUpTable = lookUpTable.concat(tempArray);

			acntIn.options[acntIn.length] = newEntry;
		}
	}

	debug(lookUpTable);
	frontID.innerText = acntIn.options[acntIn.selectedIndex].text;
}

function violateValidity() {
	if ( failCounter > 3 ) {
		debug("violateValidity()");
	
		statusLED.style.background = "url(\"Images/Red.png\")";
	
		/* violate also the front side */
		mailCounter.innerText = "";
		mailCounter.style.background = "url(\"Images/Stop.png\")";
		mailCounter.style.display = "block";
		activityIndicator.style.display = "none";
	}
	
	failCounter++;
}







/*******************/
/* widget activity */
/*******************/

window.setInterval( 'periodicCheck()', 300000 );

if ( window.widget ) {
	widget.onshow = onShow;
	widget.onhide = onHide;
	widget.onremove = deletePreferences;
}

function periodicCheck() {
	debug("periodicCheck()");

	if ( periodSav && isHidden ) {
		checkMail();
	}
}

function onShow() {
	debug("onShow()");

	isHidden = false;

	if ( !periodSav ) {
		checkMail();
	}
}

function onHide() {
	debug("onHide()");

	isHidden = true;
}

function deletePreferences() {
	debug("deletePreferences()");

	serverConnection.cancel();
	widget.setPreferenceForKey( null, (widgetID + "Account") );
	widget.setPreferenceForKey( null, (widgetID + "Password") );
	widget.setPreferenceForKey( null, (widgetID + "Periodic") );
	widget.setPreferenceForKey( null, (widgetID + "Announce") );
	widget.setPreferenceForKey( null, (widgetID + "Update") );
	widget.setPreferenceForKey( null, (widgetID + "MailValid") );
}







/******************/
/* front feedback */
/******************/

var front;
var mailCounter;
var activityIndicator;
var frontID;
var updateIndicator;

var language = "en";
var announcedMails = 0;

function publish( newMails ) {
	debug("publish( " + newMails + " )");

	mailCounter.innerText = newMails;
	mailCounter.style.background = "url(\"Images/NewMail.png\")";

	if ( newMails > 0 ) {
		if ( announceSav && (newMails > announcedMails) ) {
			announceMail();
		}

		announcedMails = newMails;
		mailCounter.style.display = "block";
	} else {
		announcedMails = 0;
		mailCounter.style.display = "none";
	}

	activityIndicator.style.display = "none";
	failCounter = 0;
}

function announceMail() {
	debug("announceMail()");

	if ( window.widget ) {
		var rnd = Math.floor( Math.random() * 3 );
		widget.system( "play " + language + ".lproj/Sounds/" + rnd + ".m4a", audioEndHandler );
	}
}

function audioEndHandler( result ) {
}

function checkForUpdate() {
	debug("checkForUpdate()");

	if ( (newVersion) && (currentVersion < newVersion) && updateSav ) {
		updateIndicator.innerText = getLocalizedString( 'updateIndicator' ) + newVersion;
		updateIndicator.style.display = "block";
	}
}







/*********************/
/* front interaction */
/*********************/

function launchMail() {
	debug("launchMail()");

	if ( window.widget ) {
		widget.openApplication( "com.apple.Mail" );
		widget.system( "osascript -e 'tell application \"Mail\" to check for new mail'", null );
	}

	announcedMails = 0;
	mailCounter.style.display = "none";
}

function showBack() {
	debug("showBack()");

	if ( window.widget ) {
		widget.setCloseBoxOffset( 35, 11 );
		widget.prepareForTransition( "ToBack" );
	}

	front.style.display = "none";
	back.style.display = "block";
	backSide = true;

	if ( window.widget ) {
		setTimeout( 'widget.performTransition();', 0 );
	}
}

function updateMe() {
	debug("updateMe()");

	if ( window.widget ) {
		widget.openURL( newVersionLink );
	}

	updateIndicator.style.display = "none";
}







/*****************/
/* back feedback */
/*****************/

var back;
var statusLED;

function loadLanguagePack() {
	debug("loadLanguagePack()");

	document.getElementById( 'accountCaption' ).innerText = getLocalizedString( 'accountCaption' );
	document.getElementById( 'passwordCaption' ).innerText = getLocalizedString( 'passwordCaption' );

	acntIn.title = getLocalizedString( 'accountPopUp' );
	passIn.title = getLocalizedString( 'passwordString' );
	periodIn.title = getLocalizedString( 'periodicBox' );
	announceIn.title = getLocalizedString( 'announceBox' );
	updateIn.title = getLocalizedString( 'updateBox' );
}







/*********************/
/* back interaction */
/*********************/

var acntIn;
var passIn;
var periodIn;
var announceIn;
var updateIn;

function selectAccount( selection ) {
	debug("selectAccount( " + selection + " )");

	violateValidity();
	failCounter = 0;
	activeType = null;
	activeHost = null;
	activeSSL = null;
	activeUser = null;
	acntSav = selection;
	frontID.innerText = acntIn.options[acntIn.selectedIndex].text;

	for ( i = 0; i < (lookUpTable.length - 1); i += 7 ) {
		if ( lookUpTable[i + 1] == acntSav ) {
			activeType = lookUpTable[i + 2];
			activeHost = lookUpTable[i + 3];
			activePort = lookUpTable[i + 4];
			activeSSL = lookUpTable[i + 5];
			activeUser = lookUpTable[i + 6];
		}
	}

	debug("activeType : " + activeType);
	debug("activeHost : " + activeHost);
	debug("activePort : " + activePort);
	debug("activeSSL : " + activeSSL);
	debug("activeUser : " + activeUser);
}

function setPeriodic( value ) {
	debug("setPeriodic( " + value + " )");

	periodSav = value;
}

function setAnnounce( value ) {
	debug("setAnnounce( " + value + " )");

	announceSav = value;
}

function setUpdate( value ) {
	debug("setUpdate( " + value + " )");

	updateSav = value;

	if ( !updateSav ) {
		updateIndicator.style.display = "none";
	}
}

function hideBack() {
	debug("hideBack()");

	/*save preferences*/
	if ( window.widget ) {
		widget.setPreferenceForKey( acntSav, (widgetID + "Account") );
		widget.setPreferenceForKey( passSav, (widgetID + "Password") );
		widget.setPreferenceForKey( periodSav, (widgetID + "Periodic") );
		widget.setPreferenceForKey( announceSav, (widgetID + "Announce") );
		widget.setPreferenceForKey( updateSav, (widgetID + "Update") );

		widget.setCloseBoxOffset( 18, 26 );
		widget.prepareForTransition( "ToFront" );
	}

	/*bugfix*/
	exitflip();

	front.style.display = "block";
	back.style.display = "none";
	backSide = false;

	if ( window.widget ) {
		setTimeout( 'widget.performTransition();', 0 );
	}

	checkMail();
}






/***********************/
/* ServerCommunication */
/***********************/

var serverConnection;
var state;
var stateCount;
var isStoring = true;
var checkDone;

function verifyMail() {
	debug("verifyMail()");

	statusLED.style.background = "url(\"Images/Yellow.png\")";
	state = "";
	stateCount = 1;

	if ( window.widget ) {
		if ( activeSSL == "YES" ) {
			if ( activeType == "POPAccount" ) {
				serverConnection = widget.system( "/usr/bin/openssl s_client -connect " + activeHost + ":995", popVerifyHandler );
				serverConnection.onreadoutput = popHandler;
			} else if ( (activeType == "iToolsAccount") || (activeType == "IMAPAccount") ) {
				serverConnection = widget.system( "/usr/bin/openssl s_client -connect " + activeHost + ":993", imapVerifyHandler );
				serverConnection.onreadoutput = imapHandler;
			} else {
				debug("no Active Type found");
			}
		} else {
			if ( activeType == "POPAccount" ) {
				serverConnection = widget.system( "/usr/bin/telnet " + activeHost + " 110", popVerifyHandler );
				serverConnection.onreadoutput = popHandler;
			} else if ( (activeType == "iToolsAccount") || (activeType == "IMAPAccount") ) {
				serverConnection = widget.system( "/usr/bin/telnet " + activeHost + " 143", imapVerifyHandler );
				serverConnection.onreadoutput = imapHandler;
			} else {
				debug("no Active Type found");
			}
		}
		
		setTimeout( "cancelCommunication();", 30000 );
	}
}

function checkMail() {
	debug("checkMail()");
	checkDone = false;
	
	if ( window.widget && !backSide ) {
		/* quirk fix (not updating instantly) */
		setTimeout( 'activityIndicator.style.display = "block";', 0 );
		state = "";
		stateCount = 1;

		if ( activeSSL == "YES" ) {
			if ( activeType == "POPAccount" ) {
				serverConnection = widget.system( "/usr/bin/openssl s_client -connect " + activeHost + ":995", popEndHandler );
				serverConnection.onreadoutput = popHandler;
			} else if ( (activeType == "iToolsAccount") || (activeType == "IMAPAccount") ) {
				serverConnection = widget.system( "/usr/bin/openssl s_client -connect " + activeHost + ":993", imapEndHandler );
				serverConnection.onreadoutput = imapHandler;
			} else {
				debug("no Active Type found");
			}
		} else {
			if ( activeType == "POPAccount" ) {
				serverConnection = widget.system( "/usr/bin/telnet " + activeHost + " 110", popEndHandler );
				serverConnection.onreadoutput = popHandler;
			} else if ( (activeType == "iToolsAccount") || (activeType == "IMAPAccount") ) {
				serverConnection = widget.system( "/usr/bin/telnet " + activeHost + " 143", imapEndHandler );
				serverConnection.onreadoutput = imapHandler;
			} else {
				debug("no Active Type found");
			}
		}
		
		setTimeout( "cancelCommunication();", 30000 );
	}
}

function popHandler( result ) {
	debug("popHandler( " + result + " )");

	state = state + result;
	var splittedState = state.split( "+OK" );

	if ( state.indexOf( "-ERR" ) != -1 ) {
		serverConnection.cancel();
		violateValidity();
		debug( "Error -ERR aborting" );
	}

	if ( splittedState.length == 2 ) {
		serverConnection.write("user " + activeUser + "\n");
	} else if ( splittedState.length == 3 ) {
		serverConnection.write("pass " + passIn.value + "\n");
	} else if ( splittedState.length == 4 ) {
		serverConnection.write("stat\n");
	} else if ( splittedState.length == 5 ) {
		serverConnection.write("quit\n");
	}
}

function popVerifyHandler(result) {
	debug("popVerifyHandler( " + result + " )");

	if ( state != "" ) {
		var splittedState = state.split( "+OK" );
	
		if ( splittedState.length == 6 ) {
			passSav = encode( passIn.value );
			mailCounter.style.display = "none";
			statusLED.style.background = "url(\"Images/Green.png\")";
			debug( "eMail verified successfully" );
			failCounter = 0;
		} else {
			serverConnection.cancel();
			violateValidity();
			debug( "Error cancelling due to lack of connectivity" );
		}
	}
	
	checkDone = true;
}

function popEndHandler(result) {
	debug("popEndHandler( " + result + " )");

	if ( state != "" ) {
		var splittedState = state.split( "+OK" );
		
		debug( "splittedState[4] : " + splittedState[4] );
		
		var stateLine = splittedState[4];
		var splittedStateLine = stateLine.split( " " );
		
		debug( "splittedStateLine[1] : " + splittedStateLine[1] );
		
		var newMails = splittedStateLine[1];
		
		var oldMails = widget.system( "/usr/bin/osascript MailWidget.scpt oldMail " + acntSav, null ).outputString;
		var temp = oldMails.split( ";" );
		oldMails = temp[0];
		
		debug( "newMails : " + newMails );
		debug( "oldMails : " + oldMails );
		
		if ( (newMails - oldMails) < 0 ) {
		//	isStoring = false;
		}
		
		if ( isStoring ) {
			publish( newMails - oldMails );
		} else {
			publish( newMails );
		}
	} else {
		serverConnection.cancel();
		violateValidity();
		debug( "Error cancelling due to lack of connectivity" );
	}
	
	checkDone = true;
}

function imapHandler( result ) {
	debug("imapHandler( " + result + " )");

	state = state + result;
	var splittedState = state.split( "a01 OK" );

	if ( state.indexOf( "a01 NO" ) != -1 ) {
		serverConnection.cancel();
		violateValidity();
		debug( "Error NO aborting" );
	}

	if ( (splittedState.length == 1) && (stateCount == 1) ) {
		serverConnection.write("a01 LOGIN \"" + activeUser + "\" " + passIn.value + "\n");
		stateCount++;
	} else if ( (splittedState.length == 2) && (stateCount == 2) ) {
		serverConnection.write("a01 SELECT \"INBOX\"\n");
		stateCount++;
	} else if ( (splittedState.length == 3) && (stateCount == 3) ) {
		serverConnection.write("a01 FETCH 1:* FLAGS\n");
		stateCount++;
	} else if ( (splittedState.length == 4) && (stateCount == 4) ) {
		serverConnection.write("a01 LOGOUT\n");
		stateCount++;
	}
}

function imapVerifyHandler(result) {
	debug("imapVerifyHandler( " + result + " )");
	
	if ( state != "" ) {
		var splittedState = state.split( "a01 OK" );
	
		if ( splittedState.length == 5 ) {
			passSav = encode( passIn.value );
			mailCounter.style.display = "none";
			statusLED.style.background = "url(\"Images/Green.png\")";
			debug( "eMail verified successfully" );
			failCounter = 0;
		} else {
			violateValidity();
			debug( "eMail was not verified successfully" );
		}
	} else {
		serverConnection.cancel();
		violateValidity();
		debug( "Error cancelling due to lack of connectivity" );
	}
	
	checkDone = true;
}

function imapEndHandler(result) {
	debug("imapEndHandler( " + result + " )");
	
	if ( state != "" ) {
		var splittedState = state.split( "a01 OK" );
		var fetchReply = splittedState[2].substr( 1 + splittedState[2].indexOf( "\n" ));
		
		debug( "fetchReply: " + fetchReply );
		
		var newMails = fetchReply.split( "FETCH" ).length - fetchReply.split( "\\Seen" ).length;
		publish( newMails );
	} else {
		serverConnection.cancel();
		violateValidity();
		debug( "Error cancelling due to lack of connectivity" );
	}
	
	checkDone = true;
}

function cancelCommunication() {
	if ( !checkDone ) {
		serverConnection.cancel();
		violateValidity();
		debug( "Error cancelling due to timeout ... retrying" );
		
		//if ()
		//checkMail();
	}
}





/**********************/
/* pasword protection */
/**********************/

function encode( password ) {
	if ( window.widget ) {
		widget.system( "/bin/echo -n \"" + password + "\" > " + widgetID, null );
		var encoded = widget.system( "/usr/bin/uuencode -m " + widgetID + " " + widgetID, null ).outputString;
		widget.system( "/bin/rm " + widgetID, null );
		
		debug(encoded);
		
		return encoded;
	}
}

function decode( password ) {
	if ( window.widget ) {
		widget.system( "/bin/echo -n \"" + password + "\" > " + widgetID, null );
		var decoded = widget.system( "/usr/bin/uudecode -o /dev/stdout " + widgetID, null ).outputString;
		widget.system( "/bin/rm " + widgetID, null );
		
		debug(decoded);
		
		return decoded;
	}
}






/***************/
/* Apple Stuff */
/***************/

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit(event) {
	if (flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function getLocalizedString(key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	return key;
}